 
 # This file shows how to extract and print all of the facts from a multifield

package require clips
clips::InitializeEnvironment

frame .f
pack .f -side top -fill both -expand true
text .f.txt -wrap word -width 80 -height 24 -yscrollcommand ".f.sy set"
scrollbar .f.sy -orient vert -command ".f.txt yview"
pack .f.sy -side right -fill y
pack .f.txt -side left -fill both -expand true

proc print {logname str} {
    .f.txt insert end $str
    update
}

clips::Load zebra.clp
clips::Reset
clips::Run 1000

set facts [clips::CreateDataObject]
clips::GetFactList $facts

# Print out the ranges of the facts
puts [clips::GetDOLength $facts]
puts [clips::GetDOBegin $facts]
puts [clips::GetDOEnd $facts]

# Get the multifield
set mf [clips::GetValue $facts]

# Loop over the facts and print some data 
for {set i [clips::GetDOBegin $facts]} { $i <= [clips::GetDOEnd $facts] } {incr i 1} {
    set ft [clips::GetMFType $mf $i]
	if {$ft == "FACT_ADDRESS"} {
	    set fv [clips::GetMFValue $mf $i]
	    .f.txt insert end "fact $i: [clips::GetFactPPForm 1024 $fv]\n"
	}
} 
