
// Magic DataObject value extractor.   Returns the right value from a data
// object dynamically
%inline %{

tclint GetAnyValue(Tcl_Interp *interp, DATA_OBJECT *d) {
  int type;
  char stemp[256];
  type = GetpType(d);
  switch(type) {
  case STRING:
  case SYMBOL:
  case INSTANCE_NAME:
    Tcl_SetResult(interp, DOPToString(d),TCL_VOLATILE);
    break;
  case FLOAT:
    Tcl_PrintDouble(interp, DOPToDouble(d), stemp);
    Tcl_SetResult(interp,stemp,TCL_VOLATILE);
    break;
  case INTEGER:
    sprintf(stemp,"%d",DOPToInteger(d));
    Tcl_SetResult(interp,stemp,TCL_VOLATILE);
    break;
  case MULTIFIELD:
    SWIG_MakePtr(stemp, GetpValue(d),"_void_p");
    Tcl_SetResult(interp,stemp,TCL_VOLATILE);    
    break;
  case INSTANCE_ADDRESS:
  case EXTERNAL_ADDRESS:
  case FACT_ADDRESS:
    SWIG_MakePtr(stemp, DOPToPointer(d),"_void_p");
    Tcl_SetResult(interp,stemp,TCL_VOLATILE);    
    break;
  default:
    break;
  }
  return TCL_OK;
}
%}
