%{

  typedef struct tcl_clips_func {
      Tcl_Interp *interp;
      char *name;
      char *tclname;
      struct tcl_clips_func *next;
  } tcl_clips_func;
  
  static tcl_clips_func  *funcs = 0;
  
  static void clipstclfunc(DATA_OBJECT *returnvalue) {
    char temp1[64],temp2[512];
    char *invokedname;
    tcl_clips_func *f;

    /* This is a *MASSIVE* hack. Not documented. Just remember to duck and cover. */
    invokedname = ExpressionFunctionCallName(CurrentExpression)->contents;
    f = funcs;
    while (f) {
      if (strcmp(f->name,invokedname) == 0) {
	SWIG_MakePtr(temp1,returnvalue,"_DATA_OBJECT_p");
	sprintf(temp2,"%s %s",f->tclname,temp1);
	if (Tcl_GlobalEval(f->interp,temp2) != TCL_OK) {
	  SetpType(returnvalue,STRING);
	  SetpValue(returnvalue,AddSymbol(f->interp->result));
	}
	return;
      }
      f = f->next;
    }
    return;
  }

  int tcl_DefineFunction(Tcl_Interp *interp, char *name, char *tclname) {
    tcl_clips_func *f;
    f = (tcl_clips_func *) malloc(sizeof(tcl_clips_func));
    f->interp = interp;
    f->name = (char *) malloc(strlen(name)+1);
    strcpy(f->name,name);
    f->tclname = (char *) malloc(strlen(tclname)+1);
    strcpy(f->tclname,tclname);
    f->next = funcs;
    funcs = f;
    return DefineFunction(name,'u',PTIF clipstclfunc, tclname);
  }
  int tcl_DefineFunction2(Tcl_Interp *interp, char *name, char *tclname, char *restrictions) {
    tcl_clips_func *f;
    f = (tcl_clips_func *) malloc(sizeof(tcl_clips_func));
    f->interp = interp;
    f->name = (char *) malloc(strlen(name)+1);
    strcpy(f->name,name);
    f->tclname = (char *) malloc(strlen(tclname)+1);
    strcpy(f->tclname,tclname);
    f->next = funcs;
    funcs = f;
    return DefineFunction2(name,'u',PTIF clipstclfunc, tclname, restrictions);
  }


%}

%name(DefineFunction) int tcl_DefineFunction(Tcl_Interp *interp, char *name, char *tclname);
%name(DefineFunction2) int tcl_DefineFunction2(Tcl_Interp *interp, char *name, char *tclname,
char *restrictions);

int RtnArgCount();
int ArgCountCheck(char *name, int restriction, int count);
int ArgRangeCheck(char *name, int min, int max);

char  *RtnLexeme(int argpos);
double RtnDouble(int argpos);
long   RtnLong(int argpos);
DATA_OBJECT *RtnUnknown(int argpos, DATA_OBJECT *d);
int    ArgTypeCheck(char *name, int argpos, int typeint, DATA_OBJECT *result);

// -----------------------------------------------------------------------------
// tcleval
// -----------------------------------------------------------------------------
%{
  static Tcl_Interp *tcleval_interp = 0;
  static void clipstcleval(DATA_OBJECT *returnvalue) {
    DATA_OBJECT d;
    char *temp, res[128];
    int ret;
    double dvalue;
    int    ivalue;

    if (ArgTypeCheck("tcleval",1,STRING,&d) == 0) {
      SetpType(returnvalue,SYMBOL);
      SetpValue(returnvalue,FalseSymbol);
      return;
    }
    temp = (char *) malloc(strlen(DOToString(d))+1);
    strcpy(temp,DOToString(d));
    ret = Tcl_GlobalEval(tcleval_interp,temp);
    if (ret == TCL_OK) {
      if (isdigit(tcleval_interp->result[0])) { 
	sprintf(res,"%0.100s",tcleval_interp->result);
	if (Tcl_GetDouble(tcleval_interp,res,&dvalue) == TCL_OK) {
	  SetpType(returnvalue,FLOAT);
	  SetpValue(returnvalue,AddDouble(dvalue));
	  free(temp);
	  return;
	} 
	if (Tcl_GetInt(tcleval_interp,res,&ivalue) == TCL_OK) {
	  SetpType(returnvalue,INTEGER);
	  SetpValue(returnvalue, AddLong(ivalue));
	  free(temp);
	  return;
	}
      }
      SetpType(returnvalue,STRING);
      SetpValue(returnvalue,AddSymbol(tcleval_interp->result));
      free(temp);
      return;
    } else {
      SetpType(returnvalue,SYMBOL);
      SetpValue(returnvalue,FalseSymbol);
      free(temp);
      return;
    }
  }

/* User defined functions */

void UserFunctions() {
  DefineFunction2("tcleval",'u', PTIF clipstcleval, "clipstcleval", "11s");
}
 %}

%init %{
  tcleval_interp = interp;   
%}

